--[[
	TitanSpeed: A simple speedometer.
	Author: Trentin - > Quel -> tainted -> TotalPackage
	Credits: Rophy (author of FuBar_Speed)
--]]

local menutext = "Titan|cffffaa00Spe|r|cffff8800ed|r"
local buttontext = "Speed: "
local ID = "Speed"

local GetPlayerMapPosition, GetMapInfo = GetPlayerMapPosition, GetMapInfo

local elap, px, py = 0, 0, 0
local speedText = ""
local setRate
local vars

local function Reset()
	SpeedData = {
		init = 1,
		["LochModan"] = 2758.33,
		["Expansion01"] = 17464.04,
		["Barrens"] = 10133.34,
		["Westfall"] = 3500.003,
		["NetherstormArena"] = 2270.837,
		["WesternPlaguelands"] = 4299.997,
		["Desolace"] = 4495.83,
		["Tanaris"] = 6900,
		["Kalimdor"] = 36799.8,
		["BloodmystIsle"] = 3262.5,
		["StonetalonMountains"] = 4883.33,
		["Alterac"] = 2800.003,
		["SearingGorge"] = 2231.253,
		["AlteracValley"] = 4237.5,
		["Hilsbrad"] = 3200,
		["EasternPlaguelands"] = 3870.83,
		["Teldrassil"] = 5091.66,
		["BlastedLands"] = 3350,
		["Mulgore"] = 5137.5,
		["Ironforge"] = 790.629,
		["Felwood"] = 5750,
		["Silverpine"] = 4200,
		["EversongWoods"] = 4925,
		["SilvermoonCity"] = 1210.6,
		["Elwynn"] = 3470.84,
		["SholazarBasin"] = 4356.4865,
		["ShattrathCity"] = 1306.25,
		["DeadwindPass"] = 2499.997,
		["Redridge"] = 2170.84,
		["AzuremystIsle"] = 4070.8,
		["BurningSteppes"] = 2929.163,
		["Moonglade"] = 2308.33,
		["Winterspring"] = 7100.003,
		["Hinterlands"] = 3850,
		["BoreanTundra"] = 5765.39,
		["Badlands"] = 2487.5,
		["Darkshore"] = 6550,
		["ZulDrak"] = 4993.741,
		["Arathi"] = 3600.003,
		["Durotar"] = 5287.5,
		["Tirisfal"] = 4518.75,
		["LakeWintergrasp"] = 2974.822,
		["SwampOfSorrows"] = 2293.75,
		["Ogrimmar"] = 1402.61,
		["Darnassis"] = 1058.33,
		["Dustwallow"] = 5250,
		["GrizzlyHills"] = 5250.185,
		["Undercity"] = 959.3754,
		["Netherstorm"] = 5574.9967,
		["Azeroth"] = 40741.2,
		["Duskwood"] = 2700.003,
		["ThousandNeedles"] = 4399.997,
		["Feralas"] = 6950,
		["Ashenvale"] = 5766.67,
		["Ghostlands"] = 3300,
		["TerokkarForest"] = 5400,
		["ScarletEnclave"] = 3162.85,
		["DunMorogh"] = 4925,
		["Zangarmarsh"] = 5027.08,
		["Wetlands"] = 4135.417,
		["Sunwell"] = 3327.09,
		["Aszhara"] = 5070.84,
		["IcecrownGlacier"] = 6271.738,
		["ArathiBasin"] = 1756.247,
		["ThunderBluff"] = 1043.75,
		["Stormwind"] = 1737.57,
		["Silithus"] = 3483.334,
		["Hellfire"] = 5164.58,
		["BladesEdgeMountains"] = 5425,
		["TheExodar"] = 1056.7,
		["HowlingFjord"] = 6046.09,
		["UngoroCrater"] = 3700.003,
		["CrystalsongForest"] = 2722.26,
		["WarsongGulch"] = 1145.837,
		["Dragonblight"] = 5609.17,
		["ShadowmoonValley"] = 5500,
		["Stranglethorn"] = 6381.25,
		["Nagrand"] = 5524.97,
	}
end


-- Main button frame and addon base
local f = CreateFrame("Button", "TitanPanelSpeedButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")

---------------------------
function f:ADDON_LOADED(a1)
---------------------------
	if a1 ~= "TitanSpeed" then return end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	
	self.registry = {
		id = ID,
		menuText = menutext,
		buttonTextFunction = "TitanPanelSpeedButton_GetButtonText",
		tooltipTitle = ID,
		tooltipTextFunction = "TitanPanelSpeedButton_GetTooltipText",
		frequency = 0.5,
		icon = "Interface\\Icons\\Ability_Rogue_Sprint.blp",
		iconWidth = 16,
		category = "Information",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,
			ShowTenth = false,
		},
	}
	
	if not SpeedData or SpeedData.init ~= 1 then
		Reset()
	end
	vars = SpeedData
	
	px, py = GetPlayerMapPosition("player")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	function f:ZONE_CHANGED_NEW_AREA()
		SetMapToCurrentZone()
	end
	WorldMapFrame:HookScript("OnHide", SetMapToCurrentZone)

	self:SetScript("OnUpdate", function(this, a1)
		elap = elap + a1
		if elap < 0.5 then return end
		
		local cx, cy = GetPlayerMapPosition("player")
		if cx == 0 and cy == 0 then
			speedText = "|cffffffff??%|r"
		elseif cx == px and cy == py then
			speedText = TitanGetVar(ID, "ShowTenth") == 1 and "|cffffffff0.0%|r" or "|cffffffff0%|r"
		else
			local zone = GetMapInfo()
			local dist = sqrt( ((px - cx) * (px - cx) * 2.25 ) + ((py - cy) * (py - cy)) )	
			local displacement = dist / elap
			px, py = cx, cy
			if setRate then
				vars[zone] = floor(1000 * 10.5 / displacement) / 1000
				ChatFrame1:AddMessage(format("TitanSpeed: Base-rate for zone %s set to %0.3f.", zone, vars[zone]))
			end

			local baserate = vars[zone]
			if baserate and baserate ~= 0 then
				fSpeed = displacement * baserate * 100 / 10.5
				if TitanGetVar(ID, "ShowTenth") == 1 then
					speedText = format("|cffffffff%.1f%%|r", fSpeed)
				else
					speedText = format("|cffffffff%d%%|r", floor(fSpeed + 0.5))
				end
			else
				speedText = "|cffffffff??%|r"
			end
		
			
		end
		setRate = false
		TitanPanelButton_UpdateButton(ID)
		elap = 0
	end)
		
	TitanPanelButton_OnLoad(self)
end

----------------------------------------------
function TitanPanelSpeedButton_GetButtonText()
----------------------------------------------
	return buttontext, speedText
end

-----------------------------------------------
function TitanPanelSpeedButton_GetTooltipText()
-----------------------------------------------
	return "Displays your moving speed as a percent\n  relative to your normal running speed.\n|cff00ff00Use: Right-click for options.|r"
end


local function ToggleRate()
	setRate = true
end
local function ToggleReset()
	StaticPopupDialogs.TITANSPEED_RESET = StaticPopupDialogs.TITANSPEED_RESET or {
		text = "Are you sure you want to reset all base-rates for TitanSpeed?",
		button1 = OKAY,
		button2 = CANCEL,
		OnAccept = Reset,
		timeout = 0,
		exclusive = 1
	}
	StaticPopup_Show("TITANSPEED_RESET")
end
local function ToggleShowTenth()
	TitanToggleVar(ID, "ShowTenth")
end
local temp = {}
local function UIDDM_Add(text, func, checked, keepShown)
	temp.text, temp.func, temp.checked, temp.keepShownOnClick = text, func, checked, keepShown
	UIDropDownMenu_AddButton(temp)
end
----------------------------------------------------
function TitanPanelRightClickMenu_PrepareSpeedMenu()
----------------------------------------------------
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menuText)
	
	UIDDM_Add("Set new rate (while running 100%)", ToggleRate, nil, nil)
	UIDDM_Add("Show tenths", ToggleShowTenth, TitanGetVar(ID, "ShowTenth"), 1)
	TitanPanelRightClickMenu_AddSpacer()
	UIDDM_Add("Reset all rates", ToggleReset, nil, nil)
	TitanPanelRightClickMenu_AddSpacer()
	
	TitanPanelRightClickMenu_AddToggleIcon(ID)
	TitanPanelRightClickMenu_AddToggleLabelText(ID)
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, ID, TITAN_PANEL_MENU_FUNC_HIDE)
end